﻿#region Copyright Notice
// ------------------------------------------------------------------------------ //
//                                                                                //
//               All contents copyright � Edward Nutting 2014                     //
//                                                                                //
//        You may not share, reuse, redistribute or otherwise use the             //
//        contents this file outside of the Fling OS project without              //
//        the express permission of Edward Nutting or other copyright             //
//        holder. Any changes (including but not limited to additions,            //
//        edits or subtractions) made to or from this document are not            //
//        your copyright. They are the copyright of the main copyright            //
//        holder for all Fling OS files. At the time of writing, this             //
//        owner was Edward Nutting. To be clear, owner(s) do not include          //
//        developers, contributors or other project members.                      //
//                                                                                //
// ------------------------------------------------------------------------------ //
#endregion
    
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kernel.FOS_System.IO.Disk
{
    /// <summary>
    /// Represents an extended boot record.
    /// </summary>
    public class EBR : MBR
    {
        /// <summary>
        /// Initializes an EBR from the specified data.
        /// </summary>
        /// <param name="aEBR">The EBR data.</param>
        public EBR(byte[] aEBR)
            : base()
        {
            //EBR contains (potentially) two partitions of same format 
            //  as MBR partition entries. So attempt to parse those
            //  two entries.
            //(Location of EBR entries are fixed)
            ParsePartition(aEBR, 446);
            ParsePartition(aEBR, 462);
        }
    }
}
